package com.ekexiu.project.hdfs;
import java.io.File;
import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.hdfs.DistributedFileSystem;
public class HdfsService {
	private Configuration configuration = new Configuration();
	private DistributedFileSystem dfs;
	private Path root = new Path("/");
	private String remoteUrl;
	


	public void setRootPath(String rootPath){
		this.root = new Path(rootPath);
	}
	
	public String getRemoteUrl() {
		return remoteUrl;
	}


	public void setRemoteUrl(String remoteUrl) {
		this.remoteUrl = remoteUrl;
		configuration.set("fs.default.name", this.remoteUrl);
		try {
			dfs = (DistributedFileSystem) FileSystem.get(configuration);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	public void upload(String path,File src) throws IOException{
		if(src.exists() && src.isDirectory()){
			Path dst  =  new Path(root,path);
			if(this.dfs.exists(dst)){
				if(!this.dfs.delete(dst,true)){
					throw new IOException("delete "+configuration.get("fs.default.name")+path.toString()+" error");
				}
			}
			if(!this.dfs.mkdirs(dst)){
				throw new IOException("mkdir "+configuration.get("fs.default.name")+path.toString()+" error");
			}
			this.dfs.copyFromLocalFile(new Path(src.getAbsolutePath()), dst);
		}
		
	}
	
	
	public static void main(String args[]) throws Exception{
		HdfsService service = new HdfsService();
		service.setRemoteUrl("hdfs://39.97.161.48:9000");
		service.upload("11",new File("D:\\pdftest"));
	}

}
