package com.ekexiu.project.storage.diacrisis;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import org.jfw.util.ConstData;
import org.jfw.util.io.IoUtil;
import org.jfw.util.log.LogFactory;
import org.jfw.util.log.Logger;

public class AiStrengthenTask implements Runnable {
	private static Logger LOG = LogFactory.getLog(AiStrengthenTask.class);
	private String taskId;
	private int taskType;
	private AiTaskService aiTaskService;

	public AiStrengthenTask(String taskId, int taskType, AiTaskService aiTaskService) {
		this.taskId = taskId;
		this.taskType = taskType;
		this.aiTaskService = aiTaskService;
	}

	@Override
	public void run() {
		String errCode = "ERR0309";// 调用异常
		File file = new File(aiTaskService.getDstPath(), taskId);
		file = new File(file, "data_desen");
		try {
			URL u = new URL("http://127.0.0.1:5003/enhance?pi=" + file.getAbsolutePath());
			HttpURLConnection httpURLConnection = (HttpURLConnection) u.openConnection();
			if (httpURLConnection.getResponseCode() == 200) {
				InputStream in = httpURLConnection.getInputStream();
				try {
					ByteArrayOutputStream out = new ByteArrayOutputStream();
					byte[] buf = new byte[128];
					int len = 0;
					while ((len = in.read(buf)) != -1) {
						if (len > 0) {
							out.write(buf, 0, len);
						}
					}
					buf = out.toByteArray();
					if (buf.length > 0) {
						String ret = new String(buf, ConstData.UTF8);
						ret = ret.trim();
						if (ret.equals("1")) {
							aiTaskService.updateTaskState(taskId, 499, null, new AiFormatTask(taskId, taskType, aiTaskService));
							return;
						}
					}
					errCode = "ERR0307";// 调用协议返回错误
				} catch (Exception e) {
					errCode = "ERR0307";// 调用协议传输异常
				} finally {
					IoUtil.close(in);
				}
			} else {
				errCode = "ERR0308";// 调用协议状态异常 http status != 200
			}
		} catch (Exception ee) {
		}
		aiTaskService.updateTaskState(taskId, 450, errCode, null);
	}
}
